/* Date.java */

import java.io.*;

class Date {

  /** Constructs a date with the given month, day and year.   If the date
   * is not valid, the entire program will halt with an error message.
   * @param month should be a number bewteen 1 and 12
   * @param day should be between 1 and the number of days in the given month
   * @param year is the year A.D. (e.g., the year 89 would mean 89 A.D., 
   * not 1989).
   */
  public Date (int month, int day, int year) {

  }

  /** Constructs a date corresponding to the given string.
   * @param s should be a string of the form "day/month/year" where
   * day must be one or two digits, month must be one or two digits,
   * and year must be between 1 and 4 digits.  If s does not match
   * these requirements or is not a valid date, the program will 
   * halt with an error message.
   */
  public Date (String s) {

  }

  /** Determines whether this date is before the date d.
   *  @return true iff this date is before d. 
   */
  public boolean isBefore (Date d) {
    return true;  // replace this line with your solution
  }

  /** Determines whether this date is after the date d.
   *  @return true iff this date is after d. 
   */
  public boolean isAfter(Date d) {
    return true; // replace this line with your solution
  }

  /** Determines the number of days between d and this date.
   *  For example, if this date is 12/15/1997 and d is 12/14/1997,
   *  the difference would be 1.  
   *  @return the number of days between d and this date.
   */
  public int difference(Date d) {
    return 0; // replace this line with your solution
  }

  /** Returns a string representation of a date in the form
   *   month/day/year, where month, day, and year are printed
   *   as integers.
   *  @return a String representation of the date.
   */
  public String toString() {
    return "stuff";  // replace this line with your solution
  }

  /** Determines whether the given date is valid.
   * @return true iff month, day and year constitute a valid date.  
   */
  public static boolean isValidDate (int month, int day, int year) {
    return true; // replace this line with your solution
  }

  /** Returns the number of days in a given month.
   * @param month is assumed to be between and 12, inclusive
   * @return the number of days in the given month
   */
  public static int daysInMonth (int month, int year) {
    return 0; // replace this line with your solution
  }


  /** Checks whether the given year is a leap year.  Leap years occur
   * on years divisible by 4, except when they are divisible by 
   * 100 but not 400. 
   * @returns true iff the given year is a leap year.
   */
  public static boolean isLeapYear (int year) {
    return true; // replace this line with your solution
  }

  /** Returns the number of day in the year.
   * @return a number between 1 and 366, inclusive, which is the number
   * of the day in the year.  (366 is only used for leap years.)
   */
  public int dayInYear () {
    return 0; // replace this line with your solution
  }

  /* Pur your private data fields here. */

  public static void main (String[] argv) {
    System.out.println("\nTesting the constructors.");
    Date d1 = new Date(1, 1, 1);
    System.out.println("Date should be 1/1/1: " + d1);
    d1 = new Date("2/4/2");
    System.out.println("Date should be 2/4/2: " + d1);
    d1 = new Date("2/29/2000");
    System.out.println("Date should be 2/29/2000: " + d1);
    d1 = new Date("2/29/1904");
    System.out.println("Date should be 2/29/1904: " + d1);

    d1 = new Date(12, 31, 1975);
    System.out.println("Date should be 12/31/1975: " + d1);
    Date d2 = new Date("1/1/1976");
    System.out.println("Date should be 1/1/1976: " + d2);
    Date d3 = new Date("1/2/1976");
    System.out.println("Date should be 1/2/1976: " + d3);

    /* Need to test isLeapYear for negatives. */

    System.out.println("\nTesting before and after.");
    System.out.println(d2 + " after " + d1 + " should be true: " + 
		       d2.isAfter(d1));
    System.out.println(d3 + " after " + d2 + " should be true: " + 
		       d3.isAfter(d2));
    System.out.println(d1 + " after " + d1 + " should be false: " + 
		       d1.isAfter(d1));
    System.out.println(d1 + " after " + d2 + " should be false: " + 
		       d1.isAfter(d2));
    System.out.println(d2 + " after " + d3 + " should be false: " + 
		       d2.isAfter(d3));

    System.out.println(d1 + " before " + d2 + " should be true: " + 
		       d1.isBefore(d2));
    System.out.println(d2 + " before " + d3 + " should be true: " + 
		       d2.isBefore(d3));
    System.out.println(d1 + " before " + d1 + " should be false: " + 
		       d1.isBefore(d1));
    System.out.println(d2 + " before " + d1 + " should be false: " + 
		       d2.isBefore(d1));
    System.out.println(d3 + " before " + d2 + " should be false: " + 
		       d3.isBefore(d2));

    /* Test difference. */
    System.out.println(d1 + " - " + d1  + " should be 0: " + 
		       d1.difference(d1));
    System.out.println(d2 + " - " + d1  + " should be 1: " + 
		       d2.difference(d1));
    System.out.println(d3 + " - " + d1  + " should be 2: " + 
		       d3.difference(d1));
  }
}
